local ChooseMount = LibStub("AceAddon-3.0"):NewAddon("ChooseMount")
local group = {}
local Masque
local LibKeyBount
SLASH_CHOOSEMOUNT1 = "/choosemount"
SLASH_CHOOSEMOUNT2 = "/cm"

function SlashCmdList.CHOOSEMOUNT(msg, editbox)
	if msg == "bind" then
		LibKeyBound:Toggle()
	end
end

ChooseMount.human = {"Black Stallion",
					"Brown Horse",
					"Chestnut Mare",
					"Palomino",
					"Pinto",
					"Swift Brown Steed",
					"Swift Palomino",
					"Swift White Steed",
					"White Stallion",
					"Vicious War Steed"}

ChooseMount.orc = {"Black Wolf",
				  "Brown Wolf",
				  "Dire Wolf",
				  "Red Wolf",
				  "Swift Brown Wolf",
				  "Swift Gray Wolf",
				  "Swift Timber Wolf",
				  "Timber Wolf",
				  "Winter Wolf",
				  "Vicious War Wolf"}

ChooseMount.dwarf = {"Black Ram",
					"Brown Ram",
					"Frost Ram",
					"Gray Ram",
					"Swift Brown Ram",
					"Swift Gray Ram",
					"Swift White Ram",
					"White Ram",
					"Vicious War Ram"}

ChooseMount.scourge = {"Black Skeletal Horse",
					  "Blue Skeletal Horse",
					  "Brown Skeletal Horse",
					  "Green Skeletal Warhorse",
					  "Ochre Skeletal Warhorse",
					  "Purple Skeletal Warhorse",
					  "Red Skeletal Horse",
					  "Vicious Skeletal Warhorse"}

ChooseMount.nightElf = {"Ancient Frostsaber",
					   "Black Nightsaber",
					   "Spotted Frostsaber",
					   "Striped Dawnsaber",
					   "Striped Frostsaber",
					   "Striped Nightsaber",
					   "Swift Frostsaber",
					   "Swift Mistsaber",
					   "Swift Stormsaber",
					   "Vicious Warsaber"}

ChooseMount.tauren = {"Brown Kodo",
					 "Gray Kodo",
					 "Great Brown Kodo",
					 "Great Gray Kodo",
					 "Great White Kodo",
					 "Green Kodo",
					 "Teal Kodo",
					 "White Kodo",
					 "Vicious War Kodo"}

ChooseMount.gnome = {"Blue Mechanostrider",
					"Green Mechanostrider",
					"Icy Blue Mechanostrider Mod A",
					"Red Mechanostrider",
					"Swift Green Mechanostrider",
					"Swift White Mechanostrider",
					"Swift Yellow Mechanostrider",
					"Unpainted Mechanostrider",
					"White Mechanostrider Mod B",
					"Vicious War Mechanostrider"}

ChooseMount.troll = {"Emerald Raptor",
					"Ivory Raptor",
					"Mottled Red Raptor",
					"Swift Blue Raptor",
					"Swift Olive Raptor",
					"Swift Orange Raptor",
					"Turquoise Raptor",
					"Violet Raptor",
					"Vicious War Raptor"}

ChooseMount.draenei = {"Brown Elekk",
					  "Gray Elekk",
					  "Great Blue Elekk",
					  "Great Green Elekk",
					  "Great Purple Elekk",
					  "Purple Elekk",
					  "Vicious War Elekk"}

ChooseMount.bloodElf = {"Black Hawkstrider",
					   "Blue Hawkstrider",
					   "Purple Hawkstrider",
					   "Red Hawkstrider",
					   "Swift Green Hawkstrider",
					   "Swift Pink Hawkstrider",
					   "Swift Purple Hawkstrider",
					   "Vicious Warstrider"}

ChooseMount.worgen = {"Mountain Horse",
					 "Swift Mountain Horse",
					 "Vicious Gilnean Warhorse"}

ChooseMount.goblin = {"Goblin Trike",
					 "Goblin Turbo-Trike",
					 "Vicious War Trike"}

ChooseMount.pandaren = {"Black Dragon Turtle",
					   "Blue Dragon Turtle",
					   "Brown Dragon Turtle",
					   "Great Black Dragon Turtle",
					   "Great Blue Dragon Turtle",
					   "Great Brown Dragon Turtle",
					   "Great Green Dragon Turtle",
					   "Great Purple Dragon Turtle",
					   "Great Red Dragon Turtle",
					   "Green Dragon Turtle",
					   "Purple Dragon Turtle",
					   "Red Dragon Turtle",
					   "Vicious War Turtle"}

ChooseMount.voidElf = {"Starcursed Voidstrider"}

ChooseMount.nightborne = {"Nightborne Manasaber"}

ChooseMount.lightforged = {"Lightforged Felcrusher"}

ChooseMount.highmountain = {"Highmountain Thunderhoof"}

ChooseMount.darkIron = {"Dark Iron Core Hound"}

ChooseMount.maghar = {"Mag'har Direwolf"}

ChooseMount.kultiran = {"Kul Tiran Charger"}

ChooseMount.zandalari = {"Zandalari Direhorn"}

ChooseMount.mechagnome = {"Mechagon Mechanostrider"}

ChooseMount.vulpera = {"Caravan Hyena"}

ChooseMount.warrior = {"Battlelord's Bloodthirsty War Wyrm"}

ChooseMount.paladin = {"Argent Charger",
					  "Argent Warhorse",
					  "Highlord's Golden Charger",
					  "Highlord's Valorous Charger",
					  "Highlord's Vengeful Charger",
					  "Highlord's Vigilant Charger",
					  "Summon Charger",
					  "Summon Warhorse"}

ChooseMount.dawnforge = {"Argent Charger",
						"Argent Warhorse",
						"Highlord's Golden Charger",
						"Highlord's Valorous Charger",
						"Highlord's Vengeful Charger",
						"Highlord's Vigilant Charger",
						"Summon Dawnforge Ram",
						"Summon Warhorse"}

ChooseMount.thalassian = {"Argent Charger",
						 "Argent Warhorse",
						 "Highlord's Golden Charger",
						 "Highlord's Valorous Charger",
						 "Highlord's Vengeful Charger",
						 "Highlord's Vigilant Charger",
						 "Summon Thalassian Charger",
						 "Summon Thalassian Warhorse"}

ChooseMount.exarch = {"Argent Charger",
					 "Argent Warhorse",
					 "Highlord's Golden Charger",
					 "Highlord's Valorous Charger",
					 "Highlord's Vengeful Charger",
					 "Highlord's Vigilant Charger",
					 "Summon Exarch's Elekk",
					 "Summon Great Exarch's Elekk"}

ChooseMount.sunwalker = {"Argent Charger",
						"Argent Warhorse",
						"Highlord's Golden Charger",
						"Highlord's Valorous Charger",
						"Highlord's Vengeful Charger",
						"Highlord's Vigilant Charger",
						"Summon Great Sunwalker Kodo",
						"Summon Sunwalker Kodo"}

ChooseMount.darkforge = {"Argent Charger",
						"Argent Warhorse",
						"Highlord's Golden Charger",
						"Highlord's Valorous Charger",
						"Highlord's Vengeful Charger",
						"Highlord's Vigilant Charger",
						"Summon Darkforge Ram",
						"Summon Warhorse"}

ChooseMount.prelate = {"Argent Charger",
					  "Argent Warhorse",
					  "Crusader's Direhorn",
					  "Highlord's Golden Charger",
					  "Highlord's Valorous Charger",
					  "Highlord's Vengeful Charger",
					  "Highlord's Vigilant Charger",
					  "Thalassian Warhorse"}

ChooseMount.hunter = {"Huntmaster's Dire Wolfhawk",
					 "Huntmaster's Fierce Wolfhawk",
					 "Huntmaster's Loyal Wolfhawk"}

ChooseMount.rogue = {"Shadowblade's Baneful Omen",
					"Shadowblade's Crimson Omen",
					"Shadowblade's Lethal Omen",
					"Shadowblade's Murderous Omen"}

ChooseMount.priest = {"High Priest's Lightsworn Seeker"}

ChooseMount.shaman = {"Farseer's Raging Tempest"}

ChooseMount.mage = {"Archmage's Prismatic Disc"}

ChooseMount.warlock = {"Dreadsteed",
					  "Felsteed",
					  "Netherlord's Accursed Wrathsteed",
					  "Netherlord's Brimstone Wrathsteed",
					  "Netherlord's Chaotic Wrathsteed"}

ChooseMount.druid = {"Grove Warden"}

ChooseMount.monk = {"Ban-Lu, Grandmaster's Companion"}

ChooseMount.deathKnight = {"Acherus Deathcharger",
						  "Crimson Deathcharger",
						  "Deathlord's Vilebrood Vanquisher",
						  "Winged Steed of the Ebon Blade"}
						  
ChooseMount.demonHunter = {"Felsaber",
						  "Slayer's Felbroken Shrieker"}

ChooseMount.allianceGround = {"Admiralty Stallion",
							 "Armored Brown Bear",
							 "Armored Irontusk",
							 "Azureshell Krolusk",
							 "Black Battlestrider",
							 "Black War Bear",
							 "Black War Elekk",
							 "Black War Mammoth",
							 "Black War Ram",
							 "Black War Steed",
							 "Black War Tiger",
							 "Champion's Treadblade",
							 "Chauffeured Mekgineer's Chopper",
							 "Crusader's White Warhorse",
							 "Dapple Gray",
							 "Darnassian Nightsaber",
							 "Dusty Rockhide",
							 "Exodar Elekk",
							 "Gnomeregan Mechanostrider",
							 "Golden King",
							 "Golden Primal Direhorn",
							 "Grand Black War Mammoth",
							 "Grand Ice Mammoth",
							 "Great Red Elekk",
							 "Highland Mustang",
							 "Ice Mammoth",
							 "Ironclad Frostclaw",
							 "Ironforge Ram",
							 "Mekgineer's Chopper",
							 "Pale Thorngrazer",
							 "Prestigious War Steed",
							 "Priestess' Moonsaber",
							 "Quel'dorei Steed",
							 "Seabraid Stallion",
							 "Smoky Charger",
							 "Spectral Steed",
							 "Stormpike Battle Charger",
							 "Stormpike Battle Ram",
							 "Stormwind Steed",
							 "Swift Alliance Steed",
							 "Swift Brewfest Ram",
							 "Swift Gray Steed",
							 "Swift Moonsaber",
							 "Swift Violet Ram",
							 "Traveler's Tundra Mammoth",
							 "Turbostrider",
							 "Vicious Black Warsaber",
							 "Vicious Gilnean Warhorse",
							 "Vicious War Basilisk",
							 "Vicious War Bear",
							 "Vicious War Elekk",
							 "Vicious War Fox",
							 "Vicious War Lion",
							 "Vicious War Mechanostrider",
							 "Vicious War Ram",
							 "Vicious War Riverbeast",
							 "Vicious War Spider",
							 "Vicious War Steed",
							 "Vicious War Turtle",
							 "Vicious Warsaber",
							 "Vicious White Warsaber",
							 "Winterspring Frostsaber",
							 "Wooly Mammoth"}

ChooseMount.hordeGround = {"Alabaster Hyena",
						  "Armored Brown Bear",
						  "Black War Bear",
						  "Black War Kodo",
						  "Black War Mammoth",
						  "Black War Raptor",
						  "Black War Wolf",
						  "Bloodflank Charger",
						  "Breezestrider Stallion",
						  "Broken Highland Mustang",
						  "Chauffeured Mechano-Hog",
						  "Crimson Primal Direhorn",
						  "Crusader's Black Warhorse",
						  "Darkspear Raptor",
						  "Forsaken Warhorse",
						  "Frostwolf Howler",
						  "Frostwolf Snarler",
						  "Gilded Ravasaur",
						  "Grand Black War Mammoth",
						  "Grand Ice Mammoth",
						  "Great Brewfest Kodo",
						  "Great Golden Kodo",
						  "Ice Mammoth",
						  "Ironside Warwolf",
						  "Kor'kron Annihilator",
						  "Mechano-Hog",
						  "Orgrimmar Wolf",
						  "Prestigious War Wolf",
						  "Red Skeletal Warhorse",
						  "Rubyshell Krolusk",
						  "Silvermoon Hawkstrider",
						  "Spectral Wolf",
						  "Sunreaver Hawkstrider",
						  "Swift Burgundy Wolf",
						  "Swift Frostwolf",
						  "Swift Horde Wolf",
						  "Swift Purple Raptor",
						  "Swift Red Hawkstrider",
						  "Swift Warstrider",
						  "Thunder Bluff Kodo",
						  "Traveler's Tundra Mammoth",
						  "Venomhide Ravasaur",
						  "Vicious Black Bonesteed",
						  "Vicious Skeletal Warhorse",
						  "Vicious War Basilisk",
						  "Vicious War Bear",
						  "Vicious War Clefthoof",
						  "Vicious War Fox",
						  "Vicious War Kodo",
						  "Vicious War Raptor",
						  "Vicious War Scorpion",
						  "Vicious War Spider",
						  "Vicious War Trike",
						  "Vicious War Turtle",
						  "Vicious War Wolf",
						  "Vicious Warstrider",
						  "Vicious White Bonesteed",
						  "Warlord's Deathwheel",
						  "White Skeletal Warhorse",
						  "Wooly Mammoth"}

ChooseMount.ground = {"Acid Belcher",
					 "Amani Battle Bear",
					 "Amani War Bear",
					 "Amber Primordial Direhorn",
					 "Amber Scorpion",
					 "Amethyst Ruinstrider",
					 "Arboreal Gulper",
					 "Arcadian War Turtle",
					 "Arcanist's Manasaber",
					 "Armored Bonehoof Tauralus",
					 "Armored Chosen Tauralus",
					 "Armored Frostboar",
					 "Armored Frostwolf",
					 "Armored Plaguerot Tauralus",
					 "Armored Razorback",
					 "Armored Razzashi Raptor",
					 "Armored War-Bred Tauralus",
					 "Ashhide Mushan Beast",
					 "Avenging Felcrusher",
					 "Azure Riding Crane",
					 "Azure Water Strider",
					 "Battle Gargon Silessa",
					 "Battle Gargon Vrednic",
					 "Battle-Bound Warhoung",
					 "Beastlord's Irontusk",
					 "Beastlord's Warwolf",
					 "Beryl Ruinstrider",
					 "Big Battle Bear",
					 "Big Blizzard Bear",
					 "Biletooth Gnasher",
					 "Black Primal Raptor",
					 "Black Riding Goat",
					 "Blackpaw",
					 "Blacksteel Battleboar",
					 "Bleakhoof Ruinstrider",
					 "Blessed Felcrusher",
					 "Blisterback Bloodtusk",
					 "Blonde Riding Yak",
					 "Bloodfang Widow",
					 "Bloodgorged Crawg",
					 "Bloodhoof Bull",
					 "Blue Marsh Hopper",
					 "Blue Shado-Pan Riding Tiger",
					 "Bonecleaver's Skullboar",
					 "Bonehoof Tauralus",
					 "Bone-White Primal Raptor",
					 "Brawler's Burly Mushan Beast",
					 "Brewfest Ram",
					 "Brilliant Direbeak",
					 "Bristling Hellboar",
					 "Brown Riding Camel",
					 "Brown Riding Goat",
					 "Bruce",
					 "Cerulean Ruinstrider",
					 "Challenger's War Yeti",
					 "Child of Torcali",
					 "Chosen Tauralus",
					 "Coalfist Gronnling",
					 "Cobalt Primordial Direhorn",
					 "Cobalt Riding Talbuk",
					 "Cobalt War Talbuk",
					 "Conquerer's Scythemaw",
					 "Core Hound",
					 "Corridor Creeper",
					 "Court Sinrunner",
					 "Craghorn Chasm-Leaper",
					 "Crimson Slavermaw",
					 "Crimson Water Strider",
					 "Crypt Gargon",
					 "Dark Riding Talbuk",
					 "Dark War Talbuk",
					 "Darkmoon Dancing Bear",
					 "Darkwarren Hardshell",
					 "Deathtusk Felboar",
					 "Deepcoral Snapdragon",
					 "Desire's Battle Gargon",
					 "Domesticated Razorback",
					 "Dread Gladiator's Proto-Drake",
					 "Dreamlight Runestag",
					 "Dune Scavenger",
					 "Elusive Quickhoof",
					 "Enchanted Dreamlight Runestag",
					 "Enchanted Shadeleaf Runestag",
					 "Enchanted Wakener's Runestag",
					 "Enchanted Winterborn Runestag",
					 "Eternal Phalynx of Courage",
					 "Eternal Phalynx of Humility",
					 "Eternal Phalynx of Loyality",
					 "Eternal Phalynx of Purity",
					 "Fathom Dweller",
					 "Felblaze Infernal",
					 "Fiery Warhorse",
					 "Flametalon of Alysrazor",
					 "Fossilized Raptor",
					 "Frenzied Feltalon",
					 "Frightened Kodo",
					 "Frostplains Battleboar",
					 "Frostshard Infernal",
					 "Garn Nighthowl",
					 "Garn Steelmaw",
					 "Giant Coldsnout",
					 "Glacial Tidestorm",
					 "Glorious Felcrusher",
					 "Golden Riding Crane",
					 "Goldenmane",
					 "Gorespine",
					 "Gorestrider Gronnling",
					 "Grand Expedition Yak",
					 "Gravestone Battle Gargon",
					 "Great Greytusk",
					 "Green Marsh Hopper",
					 "Green Primal Raptor",
					 "Green Shado-Pan Riding Tiger",
					 "Grey Riding Camel",
					 "Grey Riding Yak",
					 "Grove Defiler",
					 "Hellfire Infernal",
					 "Highmountain Elderhorn",
					 "Hopecrusher Gargon",
					 "Illidari Felstalker",
					 "Infernal Direwolf",
					 "Inquisition Gargon",
					 "Ironbound Wraithcharger",
					 "Ironhoof Destroyer",
					 "Ivory Hawkstrider",
					 "Jade Primordial Direhorn",
					 "Junkheap Drifter",
					 "Kaldorei Nightsaber",
					 "Kor'kron Juggernaut",
					 "Kor'kron War Wolf",
					 "Lil' Donkey",
					 "Llothien Prowler",
					 "Loyal Gorger",
					 "Lurid Bloodtusk",
					 "Maddened Chaosrunner",
					 "Magic Rooster",
					 "Mawsworn Soulhunter",
					 "Meat Wagon",
					 "Mechacycle Model W",
					 "Mechagon Peacekeeper",
					 "Midnight",
					 "Mighty Caravan Brutosaur",
					 "Minion of Grumpus",
					 "Mollie",
					 "Mosshide Riverwallow",
					 "Mottled Meadowstomper",
					 "Mudback Riverbeast",
					 "Obsidian Krolusk",
					 "Pale Acidmaw",
					 "Palehide Direhorn",
					 "Phalynx of Courage",
					 "Phalynx of Humility",
					 "Phalynx of Loyality",
					 "Phalynx of Purity",
					 "Plaguerot Tauralus",
					 "Predatory Bloodgazer",
					 "Primal Gladiator's Felblood Gronnling",
					 "Ratstallion",
					 "Raven Lord",
					 "Red Primal Raptor",
					 "Red Shado-Pan Riding Tiger",
					 "Regal Riding Crane",
					 "Ren's Stalwart Hound",
					 "Risen Mare",
					 "Rivendare's Deathcharger",
					 "Rockspine Basilisk",
					 "Rocktusk Battleboar",
					 "Royal Snapdragon",
					 "Russet Ruinstrider",
					 "Rusty Mechanocrawler",
					 "Sable Ruinstrider",
					 "Sandy Nightsaber",
					 "Sapphire Riverbeast",
					 "Savage Raptor",
					 "Scrapforged Mechaspider",
					 "Shadeleaf Runestag",
					 "Shadowhide Pearltusk",
					 "Shadowmane Charger",
					 "Shu-zen, the Divine Sentinel",
					 "Silver Riding Talbuk",
					 "Silver War Talbuk",
					 "Sinfall Gargon",
					 "Sinrunner Blanchy",
					 "Skullripper",
					 "Slate Primordial Direhorn",
					 "Slime Serpent",
					 "Smoky Direwolf",
					 "Snapback Scuttler",
					 "Snapdragon Kelpstalker",
					 "Snowfeather Hunter",
					 "Son of Galleon",
					 "Spawn of Horridon",
					 "Spectral Tiger",
					 "Spinemaw Gladechewer",
					 "Springfur Alpaca",
					 "Stonehide Elderhorn",
					 "Sunhide Gronnling",
					 "Swift Albino Raptor",
					 "Swift Breezestrider",
					 "Swift Forest Strider",
					 "Swift Lovebird",
					 "Swift Razzashi Raptor",
					 "Swift Shorestrider",
					 "Swift Spectral Tiger",
					 "Swift Springstrider",
					 "Swift White Hawkstrider",
					 "Swift Zhevra",
					 "Swift Zulian Panther",
					 "Swift Zulian Tiger",
					 "Tan Riding Camel",
					 "Tan Riding Talbuk",
					 "Tan War Talbuk",
					 "Terrified Pack Mule",
					 "Tomb Stalker",
					 "Trained Icehoof",
					 "Trained Meadowstomper",
					 "Trained Riverwallow",
					 "Trained Rocktusk",
					 "Trained Silverpelt",
					 "Trained Snarler",
					 "Tundra Icehoof",
					 "Twilight Avenger",
					 "Umber Nightsaber",
					 "Umber Ruinstrider",
					 "Umbral Scythehorn",
					 "Underrot Crawg",
					 "Vile Fiend",
					 "Viridian Sharptalon",
					 "Voidtalon of the Dark Star",
					 "Voracious Gorger",
					 "Wakener's Runestag",
					 "War-Bred Tauralus",
					 "Warmongering Gladiator's Felblood Gronnling",
					 "Warsong Direfang",
					 "Warstiched Darkhound",
					 "White Polar Bear",
					 "White Riding Camel",
					 "White Riding Goat",
					 "White Riding Talbuk",
					 "White War Talbuk",
					 "Wild Gladiator's Felblood Gronnling",
					 "Wild Glimmerfur Prowler",
					 "Wild Goretusk",
					 "Winterborn Runestag",
					 "Witherhide Cliffstomper",
					 "Wooly White Rhino",
					 "X-995 Mechanocat",
					 "Xinlao",
					 "Yellow Marsh Hopper"}

ChooseMount.allianceFlying = {"Alabaster Stormtalon",
							 "Ankoan Waveray",
							 "Armored Blue Dragonhawk",
							 "Armored Snowy Gryphon",
							 "Blue Dragonhawk",
							 "Dusky Waycrest Gryphon",
							 "Ebon Gryphon",
							 "Golden Gryphon",
							 "Grand Armored Gryphon",
							 "Grand Gryphon",
							 "Honeyback Harvester",
							 "Pandaren Kite",
							 "Proudmoore Sea Scout",
							 "Silver Covenant Hippogryph",
							 "Snowy Gryphon",
							 "Spectral Gryphon",
							 "Stormsong Coastwatcher",
							 "Stormwind Skychaser",
							 "Swift Blue Gryphon",
							 "Swift Green Gryphon",
							 "Swift Purple Gryphon",
							 "Swift Red Gryphon",
							 "Teldrassil Hippogryph"}

ChooseMount.hordeFlying = {"Alabaster Thunderwing",
						  "Armored Blue Wind Rider",
						  "Armored Red Dragonhawk",
						  "Bloodthirsty Dreadwing",
						  "Blue Wind Rider",
						  "Captured Swampstalker",
						  "Cobalt Pterrordax",
						  "Expedition Bloodswarmer",
						  "Grand Armored Wyvern",
						  "Grand Wyvern",
						  "Green Wind Rider",
						  "Orgrimmar Interceptor",
						  "Pandaren Kite",
						  "Red Dragonhawk",
						  "Spectral Pterrorwing",
						  "Spectral Wind Rider",
						  "Sunreaver Dragonhawk",
						  "Swift Green Wind Rider",
						  "Swift Purple Wind Rider",
						  "Swift Red Wind Rider",
						  "Swift Yellow Wind Rider",
						  "Tawny Wind Rider",
						  "Undercity Plaguebat",
						  "Unshackled Waveray",
						  "Voldunai Dunescraper"}

ChooseMount.flying = {"Abyss Worm",
					 "Aerial Unit R-21/X",
					 "Albino Drake",
					 "Amani Dragonhawk",
					 "Amber Ardenmoth",
					 "Argent Hippogryph",
					 "Armored Bloodwing",
					 "Armored Dread Raven",
					 "Armored Skyscreamer",
					 "Ascended Skymane",
					 "Ashen Pandaren Phoenix",
					 "Ashenvale Chimaera",
					 "Ashes of Al'ar",
					 "Astral Cloud Serpent",
					 "Azshari Bloatray",
					 "Azure Cloud Serpent",
					 "Azure Drake",
					 "Azure Netherwing Drake",
					 "Big Love Rocket",
					 "Black Drake",
					 "Black Proto-Drake",
					 "Black Serpent of N'Zoth",
					 "Blazing Drake",
					 "Blazing Hippogryph",
					 "Bloodbathed Frostbrood Vanquisher",
					 "Bloodgorged Hunter",
					 "Blue Drake",
					 "Blue Proto-Drake",
					 "Blue Riding Nether Ray",
					 "Bonesewn Fleshroc",
					 "Bronze Drake",
					 "Brutal Nether Drake",
					 "Bulbous Necroray",
					 "Callow Flayedwing",
					 "Cataclysmic Gladiator's Twilight Drake",
					 "Celestial Steed",
					 "Cenarion War Hippogryph",
					 "Chittering Animite",
					 "Cindermane Charger",
					 "Cloudwing Hippogryph",
					 "Clutch of Ha-Li",
					 "Clutch of Ji-Kun",
					 "Cobalt Netherwing Drake",
					 "Colossal Slaughterclaw",
					 "Corrupted Dreadwing",
					 "Corrupted Fire Hawk",
					 "Corrupted Gladiator's Proto-Drake",
					 "Corrupted Hippogryph",
					 "Crimson Cloud Serpent",
					 "Crimson Pandaren Phoenix",
					 "Cruel Gladiator's Storm Dragon",
					 "Dark Phoenix",
					 "Darkmoon Dirigible",
					 "Darkspore Mana Ray",
					 "Dauntless Duskrunner",
					 "Dazar'alor Windreaver",
					 "Deadly Gladiator's Frost Wyrm",
					 "Deathbringer's Flayedwing",
					 "Drake of the East Wind",
					 "Drake of the Four Winds",
					 "Drake of the North Wind",
					 "Drake of the South Wind",
					 "Drake of the West Wind",
					 "Dread Raven",
					 "Duskflutter Ardenmoth",
					 "Eclipse Dragonhawk",
					 "Emerald Drake",
					 "Emerald Hippogryph",
					 "Emerald Pandaren Phoenix",
					 "Enchanted Fey Dragon",
					 "Endmire Flyer",
					 "Experiment 12-B",
					 "Fearless Gladiator's Storm Dragon",
					 "Feldrake",
					 "Felfire Hawk",
					 "Felglow Mana Ray",
					 "Felsteel Annihilator",
					 "Ferocious Gladiator's Storm Dragon",
					 "Flameward Hippogryph",
					 "Furious Gladiator's Frost Wyrm",
					 "G.M.O.D.",
					 "Ghastly Charger",
					 "Gilded Prowler",
					 "Golden Cloud Serpent",
					 "Green Proto-Drake",
					 "Green Riding Nether Ray",
					 "Grievous Gladiator's Cloud Serpent",
					 "Grinning Reaver",
					 "Grove Warden",
					 "Gruesome Flayedwing",
					 "Headless Horseman's Mount",
					 "Heart of the Aspects",
					 "Hearthsteed",
					 "Heavenly Azure Cloud Serpent",
					 "Heavenly Crimson Cloud Serpent",
					 "Heavenly Golden Cloud Serpent",
					 "Heavenly Onyx Cloud Serpent",
					 "Highwind Darkmane",
					 "Hogrus, Swine of Good Fortune",
					 "Horrid Dredwing",
					 "Hulking Deathroc",
					 "Icebound Frostbrood Vanquisher",
					 "Imperial Quilen",
					 "Infested Necroray",
					 "Infinite Timereaver",
					 "Invincible",
					 "Iron Skyreaver",
					 "Ironbound Proto-Drake",
					 "Island Thunderscale",
					 "Ivory Cloud Serpent",
					 "Jade Cloud Serpent",
					 "Jade Pandaren Kite",
					 "Kau'fon",
					 "Lambent Mana Ray",
					 "Leaping Veinseeker",
					 "Leyfeather Hippogryph",
					 "Leywoven Flying Carpet",
					 "Life-Binder's Handmaiden",
					 "Lightforged Warframe",
					 "Long-Forgotten Hippogryph",
					 "Lucid Nightmare",
					 "Mail Muncher",
					 "Malevolent Drone",
					 "Malevolent Gladiator's Cloud Serpent",
					 "Marrowfang",
					 "Mecha-Mogul Mk2",
					 "Mechanized Lumber Extractor",
					 "Merciless Nether Drake",
					 "Mimiron's Head",
					 "Mottled Drake",
					 "Mystic Runesaber",
					 "Nazjatar Blood Serpent",
					 "Notorious Gladiator's Proto-Drake",
					 "Ny'alotha Allseer",
					 "Obsidian Nightwing",
					 "Onyx Cloud Serpent",
					 "Onyx Netherwing Drake",
					 "Onyxian Drake",
					 "Pestilent Necroray",
					 "Phosphorescent Stone Drake",
					 "Plagued Proto-Drake",
					 "Predatory Plagueroc",
					 "Prestigious Azure Courser",
					 "Prestigious Bloodforged Courser",
					 "Prestigious Bronze Courser",
					 "Prestigious Forest Courser",
					 "Prestigious Ivory Courser",
					 "Prestigious Midnight Courser",
					 "Prestigious Royal Courser",
					 "Prideful Gladiator's Cloud Serpent",
					 "Pureblood Fire Hawk",
					 "Pureheart Courser",
					 "Purple Netherwing Drake",
					 "Purple Riding Nether Ray",
					 "Qinsho's Eternal Hound",
					 "Rajani Warserpent",
					 "Rampart Screecher",
					 "Red Drake",
					 "Red Flying Cloud",
					 "Red Proto-Drake",
					 "Red Riding Nether Ray",
					 "Relentless Gladiator's Frost Wyrm",
					 "Riddler's Mind-Worm",
					 "Rustbolt Resistor",
					 "Rusted Proto-Drake",
					 "Ruthless Gladiator's Twilight Drake",
					 "Scintillating Mana Ray",
					 "Shadowbarb Drone",
					 "Sharkbait",
					 "Shimmermist Runner",
					 "Silent Glider",
					 "Silky Shimmermoth",
					 "Siltwing Albatross",
					 "Silver Riding Nether Ray",
					 "Silvertip Dredwing",
					 "Silverwind Larion",
					 "Sinful Gladiator's Soul Eater",
					 "Sinister Gladiator's Proto-Drake",
					 "Sintouched Deathwalker",
					 "Sky Golem",
					 "Smoldering Ember Wyrm",
					 "Soaring Skyterror",
					 "Solar Spirehawk",
					 "Spawn of Galakras",
					 "Spirit of Eche'ro",
					 "Squawks",
					 "Squeakers, the Trickster",
					 "Steamscale Incinerator",
					 "Stormcrow",
					 "Sundancer",
					 "Swift Gloomhoof",
					 "Swift Nether Drake",
					 "Swift Windsteed",
					 "The Hivemind",
					 "Thundering August Cloud Serpent",
					 "Thundering Cobalt Cloud Serpent",
					 "Thundering Jade Cloud Serpent",
					 "Thundering Onyx Cloud Serpent",
					 "Thundering Ruby Cloud Serpent",
					 "Time-Lost Proto-Drake",
					 "Twilight Drake",
					 "Twilight Harbinger",
					 "Tyrael's Charger",
					 "Tyrannical Gladiator's Cloud Serpent",
					 "Uncorrupted Voidwing",
					 "Valarjar Stormwing",
					 "Vengeful Nether Drake",
					 "Veridian Netherwing Drake",
					 "Vibrant Flutterwing",
					 "Vibrant Mana Ray",
					 "Vicious Gladiator's Twilight Drake",
					 "Vindictive Gladiator's Storm Dragon",
					 "Violet Netherwing Drake",
					 "Violet Pandaren Phoenix",
					 "Violet Proto-Drake",
					 "Vitreous Stone Drake",
					 "Volcanic Stone Drake",
					 "Warforged Nightmare",
					 "Waste Marauder",
					 "Wastewander Skyterror",
					 "Wicked Swarmer",
					 "Wild Dreamrunner",
					 "Wildseed Cradle",
					 "Winged Guardian",
					 "Witherbark Direwin",
					 "Wonderwing 2.0",
					 "Wrathful Gladiator's Frost Wyrm",
					 "Wriggling Parasite",
					 "X-51 Nether-Rocket",
					 "X-51 Nether-Rocket X-TREME",
					 "X-53 Touring Rocket",
					 "Xiwyllag ATV"}

ChooseMount.alchemy = {"Sandstone Drake"}

ChooseMount.blacksmithing = {"Steelbound Devourer"}

ChooseMount.engineering = {"Depleted-Kyparium Rocket",
						  "Flying Machine",
						  "Geosynchronous World Spinner",
						  "Turbo-Charged Flying Machine"}

ChooseMount.jewelcrafting = {"Jade Panther",
							"Jeweled Onyx Panther",
							"Ruby Panther",
							"Sapphire Panther",
							"Sunstone Panther"}

ChooseMount.leatherworking = {"Dustmane Direwolf",
							 "Great Northern Elderhorn"}

ChooseMount.tailoring = {"Creeping Carpet",
						"Flying Carpet",
						"Frosty Flying Carpet",
						"Magnificent Flying Carpet"}

ChooseMount.aquatic = {"Abyssal Seahorse",
					  "Brinedeep Bottom-Feeder",
					  "Crimson Tidestallion",
					  "Darkwater Skate",
					  "Fabious",
					  "Great Sea Ray",
					  "Inkscale Deepseeker",
					  "Pond Nettle",
					  "Riding Turtle",
					  "Saltwater Seahorse",
					  "Sea Turtle",
					  "Subdued Seahorse",
					  "Surf Jelly"}

ChooseMount.qiraji = {"Black Qiraji Battle Tank",
					 "Blue Qiraji Battle Tank",
					 "Green Qiraji Battle Tank",
					 "Red Qiraji Battle Tank",
					 "Ultramarine Qiraji Battle Tank",
					 "Yellow Qiraji Battle Tank"}

ChooseMount.raceIcons = {["Human"] = "Interface/ICONS/Ability_Mount_AlliancePVPMount",
						["Orc"] = "Interface/ICONS/Ability_Mount_HordePVPMount",
						["Dwarf"] = "Interface/ICONS/Ability_Mount_MountainRam",
						["Scourge"] = "Interface/ICONS/INV_SkeletalWarhorse",
						["NightElf"] = "Interface/ICONS/Ability_Mount_WarNightsaber",
						["Tauren"] = "Interface/ICONS/Ability_Mount_ViciousWarKodo",
						["Gnome"] = "Interface/ICONS/Ability_Mount_ViciousWarMechanostrider",
						["Troll"] = "Interface/ICONS/Ability_Mount_ViciousWarRaptor",
						["Draenei"] = "Interface/ICONS/Ability_Mount_ViciousWarElekk",
						["BloodElf"] = "Interface/ICONS/Ability_Mount_ViciousHawkstrider",
						["Worgen"] = "Interface/ICONS/INV_Mount_ViciousHorse",
						["Goblin"] = "Interface/ICONS/INV_ViciousGoblinTrike",
						["Pandaren"] = "Interface/ICONS/INV_ViciousDragonTurtleMount",
						["VoidElf"] = "Interface/ICONS/Ability_Mount_VoidElfStriderMount",
						["Nightborne"] = "Interface/ICONS/INV_NightborneRacialMount",
						["LightforgedDraenei"] = "Interface/ICONS/INV_LightforgedElekk",
						["HighmountainTauren"] = "Interface/ICONS/INV_HMMooseMount",
						["DarkIronDwarf"] = "Interface/ICONS/INV_DarkIronDwarfCoreHound",
						["MagharOrc"] = "Interface/ICONS/INV_OrcClanWorg"}

ChooseMount.classIcons = {["WARRIOR"] = "Interface/ICONS/INV_WarriorMount",
						 ["PALADIN"] = "Interface/ICONS/INV_PaladinMount_Blue",
						 ["THALASSIAN"] = "Interface/ICONS/INV_PaladinMount_Blue",
						 ["EXARCH"] = "Interface/ICONS/INV_PaladinMount_Blue",
						 ["SUNWALKER"] = "Interface/ICONS/INV_PaladinMount_Blue",
						 ["HUNTER"] = "Interface/ICONS/INV_HunterMount",
						 ["ROGUE"] = "Interface/ICONS/INV_RogueMount_Blue",
						 ["PRIEST"] = "Interface/ICONS/INV_PriestMount",
						 ["SHAMAN"] = "Interface/ICONS/INV_ShamanMount",
						 ["MAGE"] = "Interface/ICONS/INV_MageMount",
						 ["WARLOCK"] = "Interface/ICONS/INV_WarlockMount",
						 ["DRUID"] = "Interface/ICONS/INV_MooseMount",
						 ["MONK"] = "Interface/ICONS/INV_MonkMount",
						 ["DEATHKNIGHT"] = "Interface/ICONS/Ability_Mount_DKMount",
						 ["DEMONHUNTER"] = "Interface/ICONS/INV_DHMount"}

ChooseMount.factionGroundIcons = {["Alliance"] = "Interface/ICONS/INV_ViciousGoldenKing",
								 ["Horde"] = "Interface/ICONS/Ability_Mount_ViciousKorkronAnnihilator"}

ChooseMount.groundIcon = "Interface/ICONS/Ability_Mount_PolarBear_White"

ChooseMount.factionFlyingIcons = {["Alliance"] = "Interface/ICONS/INV_Misc_EliteGryphon",
								 ["Horde"] = "Interface/ICONS/INV_Misc_EliteWyvern"}

ChooseMount.flyingIcon = "Interface/ICONS/Ability_Mount_Drake_Blue"

ChooseMount.professionIcons = {["Alchemy"] = "Interface/ICONS/Inv_Misc_StoneDragonOrange",
							  ["Blacksmithing"] = "Interface/ICONS/Inv_Mount_FelCoreHoundMoun",
							  ["Engineering"] = "Interface/ICONS/Ability_Mount_Gyrocoptor",
							  ["Jewelcrafting"] = "Interface/ICONS/Ability_Mount_OnyxPanther",
							  ["Leatherworking"] = "Interface/ICONS/INV_WolfDraenorMountBrown",
							  ["Tailoring"] = "Interface/ICONS/Ability_Mount_FlyingCarpet"}

ChooseMount.aquaticIcon = "Interface/ICONS/ABILITY_MOUNT_SEAHORSE"

ChooseMount.qirajiIcon = "Interface/ICONS/INV_Misc_QirajiCrystal_02"

function ChooseMount:OnInitialize()
	self.frame = CreateFrame("FRAME", nil, UIParent)
	LibKeyBound = LibStub("LibKeyBound-1.0")
	Masque = LibStub("Masque", true)
	if Masque ~= nil then
		group = Masque:Group("Choose Mount", "Buttons")
	end
	if not chooseMountFrameX then
		chooseMountFrameX = 300
	end
	if not chooseMountFrameY then
		chooseMountFrameY = 300
	end
	self:SetupFrame(self.frame)
	LibKeyBound.RegisterCallback(self, "LIBKEYBOUND_ENABLED")
	LibKeyBound.RegisterCallback(self, "LIBKEYBOUND_DISABLED")
end

function ChooseMount:LIBKEYBOUND_ENABLED()
	print("Choose Mount Key Binding Enabled")
end

function ChooseMount:LIBKEYBOUND_DISABLED()
	print("Choose Mount Key Binding Disabled")
end

function ChooseMount:HasClassMount(class)
	return true
end

function ChooseMount:HasProfessionMount(profession)
	return profession == "Alchemy" or profession == "Blacksmithing" or profession == "Engineering" or profession == "Jewelcrafting" or profession == "Leatherworking" or profession == "Tailoring"
end

function ChooseMount.frameOnEvent(self, event)
	if event == "PLAYER_LOGIN" then
		_, ChooseMount.race = UnitRace("player")
		_, ChooseMount.class = UnitClass("player")
		if ChooseMount.class == "PALADIN" then
			if ChooseMount.race == "Dwarf" then
				ChooseMount.class = "DAWNFORGE"
			elseif ChooseMount.race == "BloodElf" then
				ChooseMount.class = "THALASSIAN"
			elseif ChooseMount.race == "Draenei" or ChooseMount.race == "Lightforged Draenei" then
				ChooseMount.class = "EXARCH"
			elseif ChooseMount.race == "Tauren" then
				ChooseMount.class = "SUNWALKER"
			elseif ChooseMount.race == "DarkIronDwarf" then
				ChooseMount.class = "DARKFORGE"
			elseif ChooseMount.race == "ZandalariTroll" then
				ChooseMount.class = "PRELATE"
			end
		end
		ChooseMount.faction = UnitFactionGroup("player")
		local profession1, profession2 = GetProfessions()
		if profession1 ~= nil then
			ChooseMount.profession1 = GetProfessionInfo(profession1)
		end
		if profession2 ~= nil then
			ChooseMount.profession2 = GetProfessionInfo(profession2)
		end
		ChooseMount:SetupButtons(self)
		if Masque ~= nil then
			group:AddButton(ChooseMount.raceButton)
			if ChooseMount:HasClassMount(ChooseMount.class) then
				group:AddButton(ChooseMount.classButton)
			end
			group:AddButton(ChooseMount.factionGroundButton)
			group:AddButton(ChooseMount.groundButton)
			group:AddButton(ChooseMount.factionFlyingButton)
			group:AddButton(ChooseMount.flyingButton)
			if ChooseMount:HasProfessionMount(ChooseMount.profession1) then
				group:AddButton(ChooseMount.profession1Button)
			end
			if ChooseMount:HasProfessionMount(ChooseMount.profession2) then
				group:AddButton(ChooseMount.profession2Button)
			end
			group:AddButton(ChooseMount.aquaticButton)
			group:AddButton(ChooseMount.qirajiButton)
			group:ReSkin()
		end
		self:UnregisterEvent("PLAYER_LOGIN")
	end
end

function ChooseMount.frameOnDragStart(self)
	if IsShiftKeyDown() then
		self:StartMoving()
	end
end

function ChooseMount.frameOnDragStop(self)
	self:StopMovingOrSizing()
	chooseMountFrameX = self:GetLeft()
	chooseMountFrameY = self:GetBottom()
end

function ChooseMount:SetupFrame(frame)
	frame:SetMovable(true)
	frame:EnableMouse(true)
	frame:SetClampedToScreen(true)
	frame:SetPoint("BOTTOMLEFT", chooseMountFrameX, chooseMountFrameY)
	frame:SetWidth(170)
	frame:SetHeight(80)
	frame:SetFrameStrata("LOW")
	frame:RegisterForDrag("LeftButton")
	frame:RegisterEvent("PLAYER_LOGIN")
	frame:SetScript("OnEvent", ChooseMount.frameOnEvent)
	frame:SetScript("OnDragStart", ChooseMount.frameOnDragStart)
	frame:SetScript("OnDragStop", ChooseMount.frameOnDragStop)
end

function ChooseMount.buttonOnClick(self)
	local mounts = {}
	if self == ChooseMount.raceButton then
		mounts = ChooseMount:SelectRace(ChooseMount.race)
	elseif self == ChooseMount.classButton then
		mounts = ChooseMount:SelectClass(ChooseMount.class)
	elseif self == ChooseMount.factionGroundButton then
		mounts = ChooseMount:SelectFactionGround(ChooseMount.faction)
	elseif self == ChooseMount.groundButton then
		mounts = ChooseMount.ground
	elseif self == ChooseMount.factionFlyingButton then
		mounts = ChooseMount:SelectFactionFlying(ChooseMount.faction)
	elseif self == ChooseMount.flyingButton then
		mounts = ChooseMount.flying
	elseif self == ChooseMount.profession1Button then
		mounts = ChooseMount:SelectProfession(ChooseMount.profession1)
	elseif self == ChooseMount.profession2Button then
		mounts = ChooseMount:SelectProfession(ChooseMount.profession2)
	elseif self == ChooseMount.aquaticButton then
		mounts = ChooseMount.aquatic
	elseif self == ChooseMount.qirajiButton then
		mounts = ChooseMount.qiraji
	end
	ChooseMount:Mount(mounts, table.getn(mounts))
end

function ChooseMount.buttonOnUpdate(self)
	if Masque ~= nil then
		group:ReSkin()
	end
end

function ChooseMount.buttonOnEnter(self)
	LibKeyBound:Set(self)
end

function ChooseMount:SelectRace(race)
	local mounts = {}
	if race == "Human" then
		mounts = self.human
	elseif race == "Orc" then
		mounts = self.orc
	elseif race == "Dwarf" then
		mounts = self.dwarf
	elseif race == "Scourge" then
		mounts = self.scourge
	elseif race == "NightElf" then
		mounts = self.nightElf
	elseif race == "Tauren" then
		mounts = self.tauren
	elseif race == "Gnome" then
		mounts = self.gnome
	elseif race == "Troll" then
		mounts = self.troll
	elseif race == "Draenei" then
		mounts = self.draenei
	elseif race == "BloodElf" then
		mounts = self.bloodElf
	elseif race == "Worgen" then
		mounts = self.worgen
	elseif race == "Goblin" then
		mounts = self.goblin
	elseif race == "Pandaren" then
		mounts = self.pandaren
	elseif race == "VoidElf" then
		mounts = self.voidElf
	elseif race == "Nightborne" then
		mounts = self.nightborne
	elseif race == "LightforgedDraenei" then
		mounts = self.lightforged
	elseif race == "HighmountainTauren" then
		mounts = self.highmountain
	elseif race == "DarkIronDwarf" then
		mounts = self.darkIron
	elseif race == "MagharOrc" then
		mounts = self.maghar
	elseif race == "KulTiran" then
		mounts = self.kultiran
	elseif race == "ZandalariTroll" then
		mounts = self.zandalari
	elseif race == "Mechagnome" then
		mounts = self.mechagnome
	elseif race == "Vulpera" then
		mounts = self.vulpera
	end
	return mounts
end

function ChooseMount:SelectClass(class)
	local mounts = {}
	if class == "WARRIOR" then
		mounts = self.warrior
	elseif class == "PALADIN" then
		mounts = self.paladin
	elseif class == "DAWNFORGE" then
		mounts = self.dawnforge
	elseif class == "THALASSIAN" then
		mounts = self.thalassian
	elseif class == "EXARCH" then
		mounts = self.exarch
	elseif class == "SUNWALKER" then
		mounts = self.sunwalker
	elseif class == "DARKFORGE" then
		mounts = self.darkforge
	elseif class == "PRELATE" then
		mounts = self.prelate
	elseif class == "HUNTER" then
		mounts = self.hunter
	elseif class == "ROGUE" then
		mounts = self.rogue
	elseif class == "PRIEST" then
		mounts = self.priest
	elseif class == "SHAMAN" then
		mounts = self.shaman
	elseif class == "MAGE" then
		mounts = self.mage
	elseif class == "WARLOCK" then
		mounts = self.warlock
	elseif class == "DRUID" then
		mounts = self.druid
	elseif class == "MONK" then
		mounts = self.monk
	elseif class == "DEATHKNIGHT" then
		mounts = self.deathKnight
	elseif class == "DEMONHUNTER" then
		mounts = self.demonHunter
	end
	return mounts
end

function ChooseMount:SelectFactionGround(faction)
	local mounts = {}
	if faction == "Alliance" then
		mounts = self.allianceGround
	elseif faction == "Horde" then
		mounts = self.hordeGround
	end
	return mounts
end

function ChooseMount:SelectFactionFlying(faction)
	local mounts = {}
	if faction == "Alliance" then
		mounts = self.allianceFlying
	elseif faction == "Horde" then
		mounts = self.hordeFlying
	end
	return mounts
end

function ChooseMount:SelectProfession(profession)
	local mounts = {}
	if profession == "Alchemy" then
		mounts = self.alchemy
	elseif profession == "Blacksmithing" then
		mounts = self.blacksmithing
	elseif profession == "Engineering" then
		mounts = self.engineering
	elseif profession == "Jewelcrafting" then
		mounts = self.jewelcrafting
	elseif profession == "Leatherworking" then
		mounts = self.leatherworking
	elseif profession == "Tailoring" then
		mounts = self.tailoring
	end
	return mounts
end

function ChooseMount:Mount(mounts, number)
	local rand
	local usable = false
	for i = 1, number do
		if IsUsableSpell(mounts[i]) then
			usable = true
			break
		end
	end
	if usable then
		repeat
			rand = math.random(1, number)
		until IsUsableSpell(mounts[rand])
		CastSpellByName(mounts[rand])
	elseif (mounts == self.allianceGround or mounts == self.hordeGround) and IsUsableSpell("Summon Chauffeur") then
		CastSpellByName("Summon Chauffeur")
	end
end

function ChooseMount:SetupButton(button, x, y, icon)
	button.GetHotkey = function()
		return GetBindingKey(('CLICK %s:LeftButton'):format(self:GetName()))
	end
	button:Show()
	button:SetWidth(30)
	button:SetHeight(30)
	button:SetPoint("BOTTOMLEFT", x, y)
	button:SetFrameStrata("MEDIUM")
	button:SetAttribute("showgrid", 1)
	button:SetAttribute("action", 150)
	button:SetScript("OnClick", self.buttonOnClick)
	button:SetScript("OnEnter", self.buttonOnEnter)
	button:SetScript("OnUpdate", self.buttonOnUpdate)
	button:SetBackdrop({bgFile = icon,
					   tile = false,
					   insets = {left = 0,
								 right = 0,
								 top = 0,
								 bottom = 0}})
end

function ChooseMount:SetupButtons(frame)
	self.raceButton = CreateFrame("CHECKBUTTON", "ChooseMountRaceButton", frame, BackdropTemplateMixin and "BackdropTemplate, ActionBarButtonTemplate")
	self:SetupButton(self.raceButton, 0, 1, ChooseMount.raceIcons[ChooseMount.race])
	if self:HasClassMount(self.class) then
		self.classButton = CreateFrame("CHECKBUTTON", "ChooseMountClassButton", frame, BackdropTemplateMixin and "BackdropTemplate, ActionBarButtonTemplate")
		self:SetupButton(self.classButton, 0, 34, ChooseMount.classIcons[ChooseMount.class])
	end
	self.factionGroundButton = CreateFrame("CHECKBUTTON", "ChooseMountFactionGroundButton", frame, BackdropTemplateMixin and "BackdropTemplate, ActionBarButtonTemplate")
	self:SetupButton(self.factionGroundButton, 35, 1, ChooseMount.factionGroundIcons[ChooseMount.faction])
	self.groundButton = CreateFrame("CHECKBUTTON", "ChooseMountGroundButton", frame, BackdropTemplateMixin and "BackdropTemplate, ActionBarButtonTemplate")
	self:SetupButton(self.groundButton, 35, 34, ChooseMount.groundIcon)
	self.factionFlyingButton = CreateFrame("CHECKBUTTON", "ChooseMountFactionFlyingButton", frame, BackdropTemplateMixin and "BackdropTemplate, ActionBarButtonTemplate")
	self:SetupButton(self.factionFlyingButton, 70, 1, ChooseMount.factionFlyingIcons[ChooseMount.faction])
	self.flyingButton = CreateFrame("CHECKBUTTON", "ChooseMountFlyingButton", frame, BackdropTemplateMixin and "BackdropTemplate, ActionBarButtonTemplate")
	self:SetupButton(self.flyingButton, 70, 34, ChooseMount.flyingIcon)
	if self:HasProfessionMount(self.profession1) then
		self.profession1Button = CreateFrame("CHECKBUTTON", "ChooseMountProfession1Button", frame, BackdropTemplateMixin and "BackdropTemplate, ActionBarButtonTemplate")
		self:SetupButton(self.profession1Button, 105, 0, ChooseMount.professionIcons[ChooseMount.profession1])
	end
	if self:HasProfessionMount(self.profession2) then
		self.profession2Button = CreateFrame("CHECKBUTTON", "ChooseMountProfession2Button", frame, BackdropTemplateMixin and "BackdropTemplate, ActionBarButtonTemplate")
		self:SetupButton(self.profession2Button, 105, 34, ChooseMount.professionIcons[ChooseMount.profession2])
	end
	self.aquaticButton = CreateFrame("CHECKBUTTON", "ChooseMountAquaticButton", frame, BackdropTemplateMixin and "BackdropTemplate, ActionBarButtonTemplate")
	self:SetupButton(self.aquaticButton, 140, 1, ChooseMount.aquaticIcon)
	self.qirajiButton = CreateFrame("CHECKBUTTON", "ChooseMounQirajiBtutton", frame, BackdropTemplateMixin and "BackdropTemplate, ActionBarButtonTemplate")
	self:SetupButton(self.qirajiButton, 140, 34, ChooseMount.qirajiIcon)
end